gtkmm 3.13.8

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::ToggleAction Class Reference

An action which can be toggled between two states. More...

`#include <gtkmm/toggleaction.h>`

Inheritance diagram for Gtk::ToggleAction:
[legend]

## Public Member Functions
virtual | ~ToggleAction ()
GtkToggleAction* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkToggleAction* | gobj () const
| Provides access to the underlying C GObject. More...
GtkToggleAction* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | toggled ()
| Emits the “toggled” signal on the toggle action. More...
void | set_active (bool is_active=true)
| Sets the checked state on the toggle action. More...
bool | get_active () const
| Returns the checked state of the toggle action. More...
void | set_draw_as_radio (bool draw_as_radio=true)
| Sets whether the action should have proxies like a radio action. More...
bool | get_draw_as_radio () const
| Returns whether the action should have proxies like a radio action. More...
Glib::SignalProxy0< void > | signal_toggled ()
Glib::PropertyProxy< bool > | property_draw_as_radio ()
| Whether the proxies for this action look like radio action proxies. More...
Glib::PropertyProxy_ReadOnly < bool > | property_draw_as_radio () const
| Whether the proxies for this action look like radio action proxies. More...
Glib::PropertyProxy< bool > | property_active ()
| Whether the toggle action should be active. More...
Glib::PropertyProxy_ReadOnly < bool > | property_active () const
| Whether the toggle action should be active. More...
Public Member Functions inherited from Gtk::Action
virtual | ~Action ()
GtkAction* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkAction* | gobj () const
| Provides access to the underlying C GObject. More...
GtkAction* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | get_name () const
| Returns the name of the action. More...
bool | is_sensitive () const
| Returns whether the action is effectively sensitive. More...
bool | get_sensitive () const
| Returns whether the action itself is sensitive. More...
void | set_sensitive (bool sensitive=true)
| Sets the :sensitive property of the action to sensitive. More...
bool | is_visible () const
| Returns whether the action is effectively visible. More...
bool | get_visible () const
| Returns whether the action itself is visible. More...
void | set_visible (bool visible=true)
| Sets the :visible property of the action to visible. More...
void | activate ()
| Emits the “activate” signal on the specified action, if it isn't insensitive. More...
Image* | create_icon (IconSize icon_size)
| This function is intended for use by action implementations to create icons displayed in the proxy widgets. More...
MenuItem* | create_menu_item ()
| Creates a menu item widget that proxies for the given action. More...
ToolItem* | create_tool_item ()
| Creates a toolbar item widget that proxies for the given action. More...
Menu* | create_menu ()
| If action provides a Gtk::Menu widget as a submenu for the menu item or the toolbar item it creates, this function returns an instance of that menu. More...
std::vector< Widget* > | get_proxies ()
| Returns the proxy widgets for an action. More...
std::vector< const Widget* > | get_proxies () const
| Returns the proxy widgets for an action. More...
void | connect_accelerator ()
| Installs the accelerator for action if action has an accel path and group. More...
void | disconnect_accelerator ()
| Undoes the effect of one call to connect_accelerator(). More...
Glib::ustring | get_accel_path () const
| Returns the accel path for this action. More...
Glib::SignalProxy0< void > | signal_activate ()
void | set_accel_path (const Glib::ustring& accel_path)
| Sets the accel path for this action. More...
void | set_accel_group (const Glib::RefPtr< AccelGroup >& accel_group)
| Sets the Gtk::AccelGroup in which the accelerator for this action will be installed. More...
void | set_label (const Glib::ustring& label)
| Sets the label of action. More...
Glib::ustring | get_label () const
| Gets the label text of action. More...
void | set_short_label (const Glib::ustring& short_label)
| Sets a shorter label text on action. More...
Glib::ustring | get_short_label () const
| Gets the short label text of action. More...
void | set_tooltip (const Glib::ustring& tooltip)
| Sets the tooltip text on action. More...
Glib::ustring | get_tooltip () const
| Gets the tooltip text of action. More...
void | set_stock_id (const StockID& stock_id)
| Sets the stock id on action. More...
StockID | get_stock_id () const
| Gets the stock id of action. More...
void | set_gicon (const Glib::RefPtr< Gio::Icon >& icon)
| Sets the icon of action. More...
Glib::RefPtr< Gio::Icon > | get_gicon ()
| Gets the gicon of action. More...
Glib::RefPtr< const Gio::Icon > | get_gicon () const
| Gets the gicon of action. More...
void | set_icon_name (const Glib::ustring& icon_name)
| Sets the icon name on action. More...
Glib::ustring | get_icon_name () const
| Gets the icon name of action. More...
void | set_visible_horizontal (bool visible_horizontal=true)
| Sets whether action is visible when horizontal. More...
bool | get_visible_horizontal () const
| Checks whether action is visible when horizontal. More...
void | set_visible_vertical (bool visible_vertical=true)
| Sets whether action is visible when vertical. More...
bool | get_visible_vertical () const
| Checks whether action is visible when horizontal. More...
void | set_is_important (bool is_important=true)
| Sets whether the action is important, this attribute is used primarily by toolbar items to decide whether to show a label or not. More...
bool | get_is_important () const
| Checks whether action is important or not. More...
void | set_always_show_image (bool always_show=true)
| Sets whether action's menu item proxies will ignore the Gtk::Settings::property_gtk_menu_images() setting and always show their image, if available. More...
bool | get_always_show_image () const
| Returns whether action's menu item proxies will always show their image, if available. More...
void | block_activate ()
| Disable activation signals from the action. More...
void | unblock_activate ()
| Reenable activation signals from the action. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| A unique name for the action. More...
Glib::PropertyProxy < Glib::ustring > | property_label ()
| The label used for menu items and buttons that activate this action. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_label () const
| The label used for menu items and buttons that activate this action. More...
Glib::PropertyProxy < Glib::ustring > | property_short_label ()
| A shorter label that may be used on toolbar buttons. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_short_label () const
| A shorter label that may be used on toolbar buttons. More...
Glib::PropertyProxy < Glib::ustring > | property_tooltip ()
| A tooltip for this action. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip () const
| A tooltip for this action. More...
Glib::PropertyProxy< StockID > | property_stock_id ()
| The stock icon displayed in widgets representing this action. More...
Glib::PropertyProxy_ReadOnly < StockID > | property_stock_id () const
| The stock icon displayed in widgets representing this action. More...
Glib::PropertyProxy < Glib::RefPtr< Gio::Icon > > | property_gicon ()
| The GIcon being displayed. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gio::Icon > > | property_gicon () const
| The GIcon being displayed. More...
Glib::PropertyProxy < Glib::ustring > | property_icon_name ()
| The name of the icon from the icon theme. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_icon_name () const
| The name of the icon from the icon theme. More...
Glib::PropertyProxy< bool > | property_visible_horizontal ()
| Whether the toolbar item is visible when the toolbar is in a horizontal orientation. More...
Glib::PropertyProxy_ReadOnly < bool > | property_visible_horizontal () const
| Whether the toolbar item is visible when the toolbar is in a horizontal orientation. More...
Glib::PropertyProxy< bool > | property_visible_vertical ()
| Whether the toolbar item is visible when the toolbar is in a vertical orientation. More...
Glib::PropertyProxy_ReadOnly < bool > | property_visible_vertical () const
| Whether the toolbar item is visible when the toolbar is in a vertical orientation. More...
Glib::PropertyProxy< bool > | property_visible_overflown ()
| When TRUE, toolitem proxies for this action are represented in the toolbar overflow menu. More...
Glib::PropertyProxy_ReadOnly < bool > | property_visible_overflown () const
| When TRUE, toolitem proxies for this action are represented in the toolbar overflow menu. More...
Glib::PropertyProxy< bool > | property_is_important ()
| Whether the action is considered important. More...
Glib::PropertyProxy_ReadOnly < bool > | property_is_important () const
| Whether the action is considered important. More...
Glib::PropertyProxy< bool > | property_hide_if_empty ()
| When TRUE, empty menu proxies for this action are hidden. More...
Glib::PropertyProxy_ReadOnly < bool > | property_hide_if_empty () const
| When TRUE, empty menu proxies for this action are hidden. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the action is enabled. More...
Glib::PropertyProxy_ReadOnly < bool > | property_sensitive () const
| Whether the action is enabled. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the action is visible. More...
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Whether the action is visible. More...
Glib::PropertyProxy < Glib::RefPtr< ActionGroup > > | property_action_group ()
| The GtkActionGroup this GtkAction is associated with, or NULL (for internal use). More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< ActionGroup > > | property_action_group () const
| The GtkActionGroup this GtkAction is associated with, or NULL (for internal use). More...
Glib::PropertyProxy< bool > | property_always_show_image ()
| Whether the image will always be shown. More...
Glib::PropertyProxy_ReadOnly < bool > | property_always_show_image () const
| Whether the image will always be shown. More...
Public Member Functions inherited from Gtk::Buildable
virtual | ~Buildable ()
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_name (const Glib::ustring& name)
| Sets the name of the buildable object. More...
Glib::ustring | get_name () const
| Gets the name of the buildable object. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ToggleAction > | create ()
static Glib::RefPtr< ToggleAction > | create (const Glib::ustring& name, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring(), bool is_active=false)
| Creates a toggle action. More...
static Glib::RefPtr< ToggleAction > | create (const Glib::ustring& name, const Gtk::StockID& stock_id, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring(), bool is_active=false)
| Creates a toggle action with a stock ID. More...
static Glib::RefPtr< ToggleAction > | create_with_icon_name (const Glib::ustring& name, const Glib::ustring& icon_name, const Glib::ustring& label, const Glib::ustring& tooltip, bool is_active=false)
| Creates a toggle action with an icon name. More...
Static Public Member Functions inherited from Gtk::Action
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Action > | create ()
static Glib::RefPtr< Action > | create (const Glib::ustring& name, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action. More...
static Glib::RefPtr< Action > | create (const Glib::ustring& name, const Gtk::StockID& stock_id, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action with a stock ID. More...
static Glib::RefPtr< Action > | create_with_icon_name (const Glib::ustring& name, const Glib::ustring& icon_name, const Glib::ustring& label, const Glib::ustring& tooltip)
| Create an action with an icon name. More...
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| ToggleAction ()
| Creates an empty toggle action. More...
| ToggleAction (const Glib::ustring& name, const StockID& stock_id=StockID(), const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring(), bool is_active=false)
| Creates a toggle action. More...
| ToggleAction (const Glib::ustring& name, const Glib::ustring& icon_name, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring(), bool is_active=false)
| Creates a toggle action with an icon name. More...
virtual void | on_toggled ()
| This is a default handler for the signal signal_toggled(). More...
Protected Member Functions inherited from Gtk::Action
| Action ()
| Creates an empty action. More...
| Action (const Glib::ustring& name, const StockID& stock_id=StockID(), const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action with a stock ID. More...
| Action (const Glib::ustring& name, const Glib::ustring& icon_name, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action with an icon name. More...
virtual Widget* | create_menu_item_vfunc ()
virtual Widget* | create_tool_item_vfunc ()
virtual void | connect_proxy_vfunc (Widget* proxy)
virtual void | disconnect_proxy_vfunc (Widget* proxy)
virtual void | on_activate ()
| This is a default handler for the signal signal_activate(). More...
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::ToggleAction > | wrap (GtkToggleAction* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Action
Glib::RefPtr< Gtk::Action > | wrap (GtkAction* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Action
typedef sigc::slot< void > | SlotActivate
| For instance, void on_activate();. More...

## Detailed Description

An action which can be toggled between two states.

A Gtk::ToggleAction corresponds roughly to a Gtk::CheckMenuItem. It has an "active" state specifying whether the action has been checked or not.

## Constructor & Destructor Documentation

virtual Gtk::ToggleAction::~ToggleAction | ( |  | ) |
| virtual

Gtk::ToggleAction::ToggleAction | ( |  | ) |
| protected

Creates an empty toggle action.

Gtk::ToggleAction::ToggleAction | ( | const Glib::ustring & | name,
|  | const StockID& | stock_id = `StockID()`,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`,
|  | bool | is_active = `false`
| ) |  |
| explicit protected

Creates a toggle action.

Parameters

  name | A unique name for the action.
  stock_id | The stock icon to display in widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.
  is_active | The default checked state of the action.

Deprecated:
  Stock IDs are deprecated, so use another constructor.

Gtk::ToggleAction::ToggleAction | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | icon_name,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`,
|  | bool | is_active = `false`
| ) |  |
| explicit protected

Creates a toggle action with an icon name.

The toggle action's icon will reflect the specified icon name in the user's icon theme.

Parameters

  name | A unique name for the action.
  icon_name | An IconTheme icon name used for widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.
  is_active | The default checked state of the action.

## Member Function Documentation

static Glib::RefPtr<ToggleAction> Gtk::ToggleAction::create | ( |  | ) |
| static

static Glib::RefPtr<ToggleAction> Gtk::ToggleAction::create | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`,
|  | bool | is_active = `false`
| ) |  |
| static

Creates a toggle action.

Parameters

  name | A unique name for the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.
  is_active | The default checked state of the action.

Returns
  A new ToggleAction.

static Glib::RefPtr<ToggleAction> Gtk::ToggleAction::create | ( | const Glib::ustring & | name,
|  | const Gtk::StockID& | stock_id,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`,
|  | bool | is_active = `false`
| ) |  |
| static

Creates a toggle action with a stock ID.

The tock ID is used to set a default icon, text and accelerator for the toggle action.

Parameters

  name | A unique name for the action.
  stock_id | The stock icon to display in widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.
  is_active | The default checked state of the action.

Returns
  A new ToggleAction.

Deprecated:
  Stock IDs are deprecated, so use another create() method.

static Glib::RefPtr<ToggleAction> Gtk::ToggleAction::create_with_icon_name | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | icon_name,
|  | const Glib::ustring & | label,
|  | const Glib::ustring & | tooltip,
|  | bool | is_active = `false`
| ) |  |
| static

Creates a toggle action with an icon name.

The toggle action's icon will reflect the specified icon name in the user's icon theme.

Parameters

  name | A unique name for the action.
  icon_name | An IconTheme icon name used for widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.
  is_active | The default checked state of the action.

Returns
  A new ToggleAction.

bool Gtk::ToggleAction::get_active | ( |  | ) | const

Returns the checked state of the toggle action.

Since gtkmm 2.4:

Deprecated: 3.10

Returns
  The checked state of the toggle action.

bool Gtk::ToggleAction::get_draw_as_radio | ( |  | ) | const

Returns whether the action should have proxies like a radio action.

Since gtkmm 2.4:

Deprecated: 3.10

Returns
  Whether the action should have proxies like a radio action.

static GType Gtk::ToggleAction::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkToggleAction* Gtk::ToggleAction::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkToggleAction* Gtk::ToggleAction::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkToggleAction* Gtk::ToggleAction::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

virtual void Gtk::ToggleAction::on_toggled | ( |  | ) |
| protected virtual

This is a default handler for the signal signal_toggled().

Glib::PropertyProxy< bool > Gtk::ToggleAction::property_active | ( |  | ) |

Whether the toggle action should be active.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::ToggleAction::property_active | ( |  | ) | const

Whether the toggle action should be active.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::ToggleAction::property_draw_as_radio | ( |  | ) |

Whether the proxies for this action look like radio action proxies.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::ToggleAction::property_draw_as_radio | ( |  | ) | const

Whether the proxies for this action look like radio action proxies.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::ToggleAction::set_active | ( | bool | is_active = `true` | ) |

Sets the checked state on the toggle action.

Since gtkmm 2.4:

Deprecated: 3.10

Parameters

  is_active | Whether the action should be checked or not.

void Gtk::ToggleAction::set_draw_as_radio | ( | bool | draw_as_radio = `true` | ) |

Sets whether the action should have proxies like a radio action.

Since gtkmm 2.4:

Deprecated: 3.10

Parameters

  draw_as_radio | Whether the action should have proxies like a radio action.

Glib::SignalProxy0< void > Gtk::ToggleAction::signal_toggled | ( |  | ) |

Slot Prototype:
  `void on_my_toggled()`

Should be connected if you wish to perform an action whenever the Gtk::ToggleAction state is changed.

Deprecated: 3.10

void Gtk::ToggleAction::toggled | ( |  | ) |

Emits the “toggled” signal on the toggle action.

Since gtkmm 2.4:

Deprecated: 3.10

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::ToggleAction > wrap | ( | GtkToggleAction * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.